package com.unipi.talepis.bscplh20248;

import java.util.ArrayList;
import java.util.List;

public class Main {
    static List<IDoSomething> doSomethings = new ArrayList<>();
    public static void main(String[] args) {
        Food food1 = new Food();
        myMethod(food1);
        myMethod(new Camera());
        new Camera();//anonymous object
        myMethod(new IDoSomething() {
            @Override
            public void doSomething() {
                System.out.println("Hello Students!");
            }
        });
        //professorMethod(new Food());
        //professorMethod(new Camera());
        professorMethod(new Student());
        doSomethings.add(food1);
        doSomethings.add(new Camera());
        doSomethings.add(new Student());
        System.out.println("---------------------");
        for(IDoSomething something : doSomethings){
            something.doSomething();
        }
    }
    static void myMethod(IDoSomething something){
        something.doSomething();
    }
    static void professorMethod(ICombine combined){
        combined.speak();
        combined.doSomething();
    }
}